<?php

namespace App\Filament\Resources;

use App\Filament\Exports\NotInStockExporter;
use App\Filament\Imports\NotInStockImporter;
use App\Filament\Resources\NotInStockResource\Pages;
use App\Models\NotInStock;
use App\Models\StickerMaster;
use Filament\Facades\Filament;
use Filament\Forms;
use Filament\Forms\Form;
use Filament\Resources\Resource;
use Filament\Tables;
use Filament\Tables\Table;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletingScope;
use Filament\Tables\Actions\ExportAction;
use Filament\Tables\Actions\ImportAction;


class NotInStockResource extends Resource
{
    protected static ?string $model = NotInStock::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?string $navigationGroup = 'Cycle Count Software';

    public static function form(Form $form): Form
    {
        return $form
            ->schema([
                Forms\Components\Select::make('plant_id')
                    ->label('Plant')
                    ->reactive()
                    ->relationship('plant', 'name')
                    ->required(),
                Forms\Components\Select::make('sticker_master_id')
                    ->label('Item Code')
                    ->reactive()
                    ->required()
                    ->searchable()
                    ->options(function ($get) {
                        if (! $get('plant_id')) {
                            return [];
                        }

                        return StickerMaster::with('item')
                            ->where('plant_id', $get('plant_id'))
                            ->get()
                            ->pluck('item.code', 'id')
                            ->toArray();
                    }),
                Forms\Components\TextInput::make('location')
                    ->label('Location'),
                Forms\Components\TextInput::make('bin')
                    ->label('Bin'),
                Forms\Components\TextInput::make('serial_number')
                    ->label('Serial Number'),
                Forms\Components\TextInput::make('batch')
                    ->label('Batch'),
                Forms\Components\TextInput::make('quantity')
                    ->label('Quantity'),
                Forms\Components\TextInput::make('doc_no')
                    ->label('Doc No'),
                Forms\Components\Select::make('type')
                    ->label('Type')
                    ->options([
                        '0' => 'FG',
                        '1' => 'NON-FG',
                    ]),
                Forms\Components\TextInput::make('motor_scanned_status')
                    ->label('Motor Scanned Status'),
                Forms\Components\TextInput::make('pump_scanned_status')
                    ->label('Pump Scanned Status'),
                Forms\Components\TextInput::make('capacitor_scanned_status')
                    ->label('Capacitor Scanned Status'),
                Forms\Components\TextInput::make('scanned_status_set')
                    ->label('Scanned Status Set'),
                Forms\Components\TextInput::make('panel_box_item_code')
                    ->label('Panel Box Item Code'),
                Forms\Components\TextInput::make('panel_box_supplier')
                    ->label('Panel Box Supplier'),
                Forms\Components\TextInput::make('panel_box_sno')
                    ->label('Panel Box Sno'),
                Forms\Components\TextInput::make('scanned_status')
                    ->label('Scanned Status'),
                Forms\Components\TextInput::make('scanned_quantity')
                    ->label('Scanned Quantity'),
                Forms\Components\Hidden::make('created_by')
                    ->label('Created By')
                    ->default(Filament::auth()->user()?->name),
                Forms\Components\Hidden::make('updated_by')
                    ->label('Updated By')
                    ->default(Filament::auth()->user()?->name),
            ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->columns([
                Tables\Columns\TextColumn::make('No.')
                    ->label('No.')
                    ->getStateUsing(function ($record, $livewire, $column, $rowLoop) {
                        $paginator = $livewire->getTableRecords();
                        $perPage = method_exists($paginator, 'perPage') ? $paginator->perPage() : 10;
                        $currentPage = method_exists($paginator, 'currentPage') ? $paginator->currentPage() : 1;

                        return ($currentPage - 1) * $perPage + $rowLoop->iteration;
                    }),
                Tables\Columns\TextColumn::make('plant.name')
                    ->label('Plant')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('stickerMaster.item.code')
                    ->label('Item Code')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('type')
                    ->label('Type')
                    ->alignCenter()
                    ->searchable()
                    ->formatStateUsing(fn ($state) => match ($state) {
                        '0' => 'FG',
                        '1' => 'NON-FG',
                        default => '-',
                    })
                    ->sortable(),
                Tables\Columns\TextColumn::make('location')
                    ->label('Location')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('bin')
                    ->label('Bin')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('serial_number')
                    ->label('Serial Number')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('batch')
                    ->label('Batch')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('quantity')
                    ->label('Quantity')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('doc_no')
                    ->label('Document Number')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('motor_scanned_status')
                    ->label('Motor Scanned Status')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('pump_scanned_status')
                    ->label('Pump Scanned Status')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('capacitor_scanned_status')
                    ->label('Capacitor Scanned Status')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('scanned_status_set')
                    ->label('Scanned Status Set')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('panel_box_item_code')
                    ->label('Panel Box Item Code')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('panel_box_supplier')
                    ->label('Panel Box Supplier')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('panel_box_sno')
                    ->label('Panel Box Serial Number')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('scanned_status')
                    ->label('Scanned Status')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('scanned_quantity')
                    ->label('Scanned Quantity')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('created_at')
                    ->label('Created At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('updated_at')
                    ->label('Updated At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('deleted_at')
                    ->label('Deleted At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
            ])
            ->filters([
                Tables\Filters\TrashedFilter::make(),
            ])
            ->actions([
                Tables\Actions\ViewAction::make(),
                Tables\Actions\EditAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                    Tables\Actions\ForceDeleteBulkAction::make(),
                    Tables\Actions\RestoreBulkAction::make(),
                ]),
            ])
            ->headerActions([
                ImportAction::make()
                    ->label('Import Not In Stock')
                    ->color('warning')
                    ->importer(NotInStockImporter::class)
                    ->visible(function () {
                        return Filament::auth()->user()->can('view import not in stock');
                    }),
                ExportAction::make()
                    ->label('Export Not In Stock')
                    ->color('warning')
                    ->exporter(NotInStockExporter::class)
                    ->visible(function () {
                        return Filament::auth()->user()->can('view export not in stock');
                    }),
            ]);
    }

    public static function getRelations(): array
    {
        return [
            //
        ];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListNotInStocks::route('/'),
            'create' => Pages\CreateNotInStock::route('/create'),
            'view' => Pages\ViewNotInStock::route('/{record}'),
            'edit' => Pages\EditNotInStock::route('/{record}/edit'),
        ];
    }


    public static function getEloquentQuery(): Builder
    {
        return parent::getEloquentQuery()
            ->withoutGlobalScopes([
                SoftDeletingScope::class,
            ]);
    }
}
